# This file was autogenerated by the 'packer hcl2_upgrade' command. We
# recommend double checking that everything is correct before going forward. We
# also recommend treating this file as disposable. The HCL2 blocks in this
# file can be moved to other files. For example, the variable blocks could be
# moved to their own 'variables.pkr.hcl' file, etc. Those files need to be
# suffixed with '.pkr.hcl' to be visible to Packer. To use multiple files at
# once they also need to be in the same folder. 'packer inspect folder/'
# will describe to you what is in that folder.

# Avoid mixing go templating calls ( for example ```{{ upper(`string`) }}``` )
# and HCL2 calls (for example '${ var.string_value_example }' ). They won't be
# executed together and the outcome will be unknown.

# All generated input variables will be of 'string' type as this is how Packer JSON
# views them; you can change their type later on. Read the variables type
# constraints documentation
# https://www.packer.io/docs/templates/hcl_templates/variables#type-constraints for more info.

packer {
  required_plugins {
    proxmox = {
      version = " >= 1.1.3"
      source = "github.com/hashicorp/proxmox"
    }
  }
}

variable "proxmox_api_url" {
  type    = string
  default = ""
}

variable "proxmox_node" {
  type    = string
  default = "cobra"
}

variable "proxmox_username" {
  type    = string
  default = ""
  sensitive = true
}

variable "proxmox_api_token_secret" {
  type    = string
  default = ""
  sensitive = true
}

variable "rocky_image" {
  type    = string
  default = "Rocky-9.2-x86_64-dvd.iso"
}

variable "proxmox_iso_pool" {
  type    = string
  default = "nas-iso:iso"
}

variable "proxmox_storage_format" {
  type    = string
  default = "raw"
}

variable "proxmox_storage_pool" {
  type    = string
  default = "local-lvm"
}

variable "proxmox_storage_pool_type" {
  type    = string
  default = "lvm"
}

variable "template_description" {
  type    = string
  default = "Rocky Linux 9.2 Template"
}

variable "template_name" {
  type    = string
  default = "rockylinux-9-cloudinit-template"
}

variable "version" {
  type    = string
  default = "9.2"
}

# source blocks are generated from your builders; a source can be referenced in
# build blocks. A build block runs provisioner and post-processors on a
# source. Read the documentation for source blocks here:
# https://www.packer.io/docs/templates/hcl_templates/blocks/source
source "proxmox" "rockylinux-9" {
  # Proxmox Connection Settings
  proxmox_url          = "${var.proxmox_api_url}"
  username             = "${var.proxmox_username}"
  token                = "${var.proxmox_api_token_secret}"
  # (Optional) Skip TLS Verification
  insecure_skip_tls_verify = true

  # VM General Settings
  node                 = "${var.proxmox_node}"
  vm_id                = "9005"
  vm_name              = var.template_name
  # os                   = "l26"
  template_name        = "${var.template_name}"
  template_description = "${var.template_description}"
  #tags                 = "template;vm;rocky;9;lts"

  # VM OS Settings
  # (Option 1) Local ISO File
  iso_file                 = "${var.proxmox_iso_pool}/${var.rocky_image}"
  # - or -
  # (Option 2) Download ISO
  # iso_url      = "https://releases.ubuntu.com/22.04.1/ubuntu-22.04.1-live-server-amd64.iso"
  # iso_checksum = "10f19c5b2b8d6db711582e0e27f5116296c34fe4b313ba45f9b201a5007056cb"
  # iso_storage_pool = "nas-iso"
  unmount_iso      = true

  # VM System Settings
  qemu_agent = true
  
  # VM Hard Disk Settings
  scsi_controller      = "virtio-scsi-single"

  disks {
    disk_size         = "8G"
    format            = "${var.proxmox_storage_format}"
    storage_pool      = "${var.proxmox_storage_pool}"
    storage_pool_type = "${var.proxmox_storage_pool_type}"
    type              = "scsi"
  }

  # VM CPU Settings
  cores        = "2"
  cpu_type     = "Nehalem"

  # VM Memory Settings
  memory                   = "2048"

  # VM Network Settings
  network_adapters {
    model  = "virtio"
    bridge = "vmbr0"
  }

  # VM Cloud-Init Settings
  cloud_init              = true
  cloud_init_storage_pool = "local-lvm"

  # PACKER Boot Commands
  boot_command = ["<tab> text inst.ks=http://{{ .HTTPIP }}:{{ .HTTPPort }}/inst.ks<enter><wait>"]
  boot_wait    = "10s"

  # PACKER Autoinstall Settings
  http_directory           = "http"
  # (Optional) Bind IP Address and Port
  # http_bind_address = "0.0.0.0"
  # http_port_min = 8802
  # http_port_max = 8802
  
  ssh_port             = 22
  ssh_username         = "root"

  # (Option 1) Add your Password here
  # ssh_password = ""
  # - or -
  # (Option 2) Add your Private SSH KEY file here
  ssh_password         = "Packer"
  # ssh_private_key_file = "~/.ssh/packer"
  
  # Raise the timeout, when installation takes longer
  ssh_timeout          = "15m"
}

# a build block invokes sources and runs provisioning steps on them. The
# documentation for build blocks can be found here:
# https://www.packer.io/docs/templates/hcl_templates/blocks/build
build {
  name    = "rocky9"
  sources = ["source.proxmox.rockylinux-9"]

  provisioner "shell" {
    inline = ["yum install -y cloud-init qemu-guest-agent cloud-utils-growpart gdisk", "systemctl enable qemu-guest-agent", "shred -u /etc/ssh/*_key /etc/ssh/*_key.pub", "rm -f /var/run/utmp", ">/var/log/lastlog", ">/var/log/wtmp", ">/var/log/btmp", "rm -rf /tmp/* /var/tmp/*", "unset HISTFILE; rm -rf /home/*/.*history /root/.*history", "rm -f /root/*ks", "passwd -d root", "passwd -l root", "rm -f /etc/ssh/ssh_config.d/allow-root-ssh.conf"]
    only   = ["proxmox"]
  }

}
